<template>
    <v-select
        v-model="selected"
        :items="storages"
        item-text="name"
        item-value="path"
        return-object
        @change="handleStorageChange"
        class="ml-4 mr-4 mb-2 omm-storage-switch"
        persistent-hint
        hint="Change storage"
    >
        <template v-slot:item="{ item, on, attrs }">
            <v-list-item class="omm-storage-switch-item" v-bind="attrs">
                <v-list-item-content>
                    <v-list-item-title class="d-flex">
                        <span
                            class="omm-storage-switch-item__label d-flex align-center flex-grow-1"
                            v-on="on"
                        >
                          {{ item.name }}
                        </span>

                        <v-btn
                            icon
                            small
                            @click="handleStorageUnlink($event, item)"
                        >
                          <v-icon small>mdi-close-circle-outline</v-icon>
                        </v-btn>

                    </v-list-item-title>
                </v-list-item-content>


            </v-list-item>
        </template>
        <template slot="append-item">
            <div class="d-flex justify-center">
                <v-btn small text class="mt-2 mb-1" @click="handleAddStorageClick">Add new storage</v-btn>
            </div>
        </template>
    </v-select>


</template>

<script lang="ts">
import { computed, ComputedRef, defineComponent, Ref, ref, watch } from '@vue/composition-api';
import { useObservers, useContents, useDialogs, useSettings, useTreeView } from "@/compositions";
import { AppStorage } from '@/ts';
import DeleteStorageDialog from "@/components/dialogs/DeleteStorageDialog.vue";
import CreateStorageDialog from "@/components/dialogs/CreateStorageDialog.vue";

export default defineComponent({
    name: "AppStorageSwitch",
    setup() {
        const storages: ComputedRef<AppStorage[]> = computed(() => {
           return useSettings().getStorage.value;
        });

        const currentStorage: ComputedRef<AppStorage> = useContents().getCurrentStorage;

        const selected: Ref<AppStorage|undefined> = ref();

        const handleStorageChange = async (storage: AppStorage) => {
            useContents().setCurrentStorage(storage);

            await useTreeView().updateTreeContents();

            const rootDir = useTreeView().getRoot.value;

            useTreeView().selectFirstFile(rootDir);

            await useObservers().notifyObservers('storageHasChanged');
        }

        const unwatchCurrentStorage = watch(currentStorage,() => {
            selected.value = currentStorage.value;
            unwatchCurrentStorage();
        });

        const handleAddStorageClick = () => {
            useDialogs().activateDialog('createStorage', CreateStorageDialog);
        }

        const handleStorageUnlink = (e: MouseEvent, storage: AppStorage) => {
            const props = { storage }
            useDialogs().activateDialog('deleteStorage', DeleteStorageDialog, { props });
        }

        return { storages, selected, handleStorageChange, handleAddStorageClick, handleStorageUnlink };
    }
});
</script>

<style scoped lang="scss">
.omm-storage-switch-item {
    &__label {
        cursor: pointer;
    }
}
</style>